FinalProject/cPhilosophy/cPhilosophy/urls.py
from django.contrib import admin
from django.urls import path, include

from mainpages import views
from . import  settings
from django.contrib.staticfiles.urls import static
from django.contrib.staticfiles.urls import staticfiles_urlpatterns


urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('mainpages.urls')),
    path('accounts/', include('django.contrib.auth.urls'))
]

if settings.DEBUG: # new
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
urlpatterns += staticfiles_urlpatterns()

FinalProject/cPhilosophy/mainpages/urls.py
from django.urls import path
from . import views
from django.contrib.auth import views as auth_views

urlpatterns = [
    # Index URL

    path('password-reset/', auth_views.PasswordResetView.as_view(template_name='registration/password_reset_form.html'),
         name='password_reset'),
    path('password-reset-confirm/<uidb64>/<token>/',
         auth_views.PasswordResetConfirmView.as_view(template_name='registration/password_reset_confirm.html'),
         name='password_reset_confirm'),
    path('password-reset/done/',
         auth_views.PasswordResetDoneView.as_view(template_name='registration/password_reset_done.html'),
         name='password_reset_done'),
    path('password-reset-complete/',
         auth_views.PasswordResetCompleteView.as_view(template_name='registration/password_reset_complete.html')),

         path('', views.HomePage.as_view(), name='home'),

         # SubCategory URL
         path('categories/<int:par_category>/', views.SubCategory.as_view(), name='computer_science'),

         # Products view URL that correspond to a SubCategory
         path('products/<int:category_pk>/list-products/', views.ProductsView.as_view(), name='category_products_list'),

         # URL for visualizing the product details
         path('details/<int:pk>/', views.ProductDetails.as_view(), name="prod_details"),

         # Product CRUD URLs for Admin Pannel
         path("product-view", views.ProductList.as_view(), name="product_view"),
         path("product-create", views.ProductCreate.as_view(), name="product_create"),
         path("product-view/update/<int:pk>/", views.ProductUpdate.as_view(), name="product_update"),
         path("product-view/delete/<int:pk>/", views.ProductDelete.as_view(), name="product_delete"),

         # Category CRUD URLs for Admin Pannel
         path("category-view", views.CategoryView.as_view(), name="category_view"),
         path("category-create", views.CategoryCreate.as_view(), name="category_create"),
         path("category-view/update/<int:pk>", views.CategoryUpdate.as_view(), name="category_update"),
         path("category-view/delete/<int:pk>", views.CategoryDelete.as_view(), name="category_delete"),

         # Review CRUD URLs for a given product
         path('product/review/<int:pk>', views.ProductReview.as_view(), name="prod-review-create"),
         path('product/review/comments/<int:pk>', views.ProductReviewDetails.as_view(), name='prod-view-review'),
         path('product/review/delete/<int:pk>', views.DeleteReview.as_view(), name='delete-review'),
         path("product/review/update/<int:review_pk>/<int:product_pk>/", views.UpdateReview.as_view(),
              name='update-review'),

         # SignUp CRUD URLs for an user
         path('signup/', views.SignUpView.as_view(), name='signup'),
         path('update_profile/<int:pk>/', views.ProfileUpdate.as_view(), name='update_profile'),
         path("update_profile/succesful", views.profile_success, name='success_update'),
         path('profile/<int:pk>/', views.ProfileView.as_view(), name="profile"),
         path('delete_profile/<int:pk>/', views.ProfileDelete.as_view(), name="delete_profile"),

         #  Order view
          path("order/view/user/<int:pk>/", views.OrdersView.as_view(), name="order-history"),
          path("order/view/user/items/<int:pk>/", views.OrderedItems.as_view(), name="ordered-items"),

         # Search engine URL
         path("search_results", views.search, name="search_results"),

         # URLs for the process of adding a product to the cart
         path("cart", views.cart_view, name="cart"),
         path("cart-add", views.add_to_cart, name="cart-add"),
         path("cart/<int:id>/increment", views.increment, name="increment"),
         path("cart/<int:id>/decrement", views.decrement, name="decrement"),
         path("cart/<int:pk>/", views.CartItemDelete.as_view(), name='cart_delete'),
         path("cart_quantity", views.quantity_input_cart, name="cart_qu"),
         path("cart-delete", views.cart_items_delete, name="cart-delete-all"),

         # URLs for placing an order
         path("order/", views.my_form_view, name='order'),
         path("order/sent", views.sent_form, name="sent-form"),

         # URLs for payment handling
         path('thank-you', views.thank_you, name='thank-you'),
         path('cancel/', views.CancelView.as_view(), name='cancel'),
         path('payment/err/', views.RefreshView.as_view(), name='refresh'),
         path('land/', views.OrderLandPageView.as_view(), name='landing-page'),
         path("payment", views.payhandling, name="payment_handling"),

         # URLs for info desk about the website
         path("privacy/", views.PrivacyView.as_view(), name="privacy"),
         path('cookies/', views.CookiesView.as_view(), name="cookies"),
         path('ads/', views.AdsView.as_view(), name='ads'),
         path('terms/', views.TermsView.as_view(), name='terms'),
         path('business/', views.BusinessView.as_view(), name='business'),
         path('help/', views.HelpView.as_view(), name='help')

]

FinalProject/cPhilosophy/mainpages/forms.py
from django import forms
from django.contrib.auth.forms import UserCreationForm, UserChangeForm
from .models import CustomUser, Order, Products
import re


class SignUpForm(UserCreationForm):
    first_name = forms.CharField(max_length=30, required=False, help_text='Optional')
    last_name = forms.CharField(max_length=30, required=False, help_text='Optional')
    email = forms.EmailField(max_length=254, help_text='Enter a valid email address')
    street = forms.CharField(max_length=50, required=True, help_text='Required')
    number = forms.CharField(max_length=50, required=True, help_text='Required')
    city = forms.CharField(max_length=50, required=True, help_text='Required')
    country = forms.CharField(max_length=50, required=True, help_text='Required')
    zip_code = forms.CharField(max_length=50, required=True, help_text='Required')
    phone_number = forms.CharField(max_length=15, required=False, help_text="Optional")
    profile_image = forms.ImageField(required=False, help_text="Optional")


    def clean(self):
        super(SignUpForm,self).clean()
        emails = CustomUser.objects.values_list('email', flat=True)
        usernames = CustomUser.objects.values_list('username', flat=True)
        email = self.cleaned_data.get('email')
        username = self.cleaned_data.get("username")
        if email in emails:
            self.add_error('email', f"'{email}' is already taken. Please insert another email")
        if username in usernames:
            self.add_error('username', f"{username} is already taken. Please insert another username")


    class Meta:
        model = CustomUser
        fields = [
            'username',
            'first_name',
            'last_name',
            'email',
            'password1',
            'password2',
            'street',
            'number',
            'city',
            'country',
            'zip_code',
            'profile_image',
        ]

class OrderForm(forms.Form):
    first_name = forms.CharField(max_length=30,  help_text='Required')
    last_name = forms.CharField(max_length=30,  help_text='Required')
    email = forms.EmailField(max_length=254, help_text='Enter a valid email address')
    street = forms.CharField(max_length=50,  help_text='Required')
    number = forms.CharField(max_length=50, required=True, help_text='Required')
    city = forms.CharField(max_length=50, help_text='Required')
    country = forms.CharField(max_length=50, help_text='Required')
    zip_code = forms.CharField(max_length=50, required=True, help_text='Required')
    phone_number = forms.CharField(max_length=16, help_text="Required")
    choices = [("cash", "On delivery, cash"), ("online", "via online payment",)]
    payment = forms.ChoiceField(choices=choices, widget=forms.Select)


    def clean(self):
        super(OrderForm, self).clean()
        # phone_number = self.cleaned_data.get('phone_number')
        # if (not re.match("^\s*(?:\+?(\d{1,3}))?[-. (]*(\d{3})[-. )]*(\d{3})[-. ]*(\d{4})(?: *x(\d+))?\s*$", phone_number)):
        #     self.add_error("phone_number", "Invalid number")
        number = self.cleaned_data.get("zip_code")
        if re.match(r"[A-Za-z]", number):
            self.add_error('zip_code', "Invalid zip code")






class ProfileForm(forms.ModelForm):
    class Meta:
        model = CustomUser
        fields = [
            'username',
            'first_name',
            'last_name',
            'email',
            'street',
            'number',
            'city',
            'country',
            'zip_code',
            'profile_image',
            ]

class QuantityForm(forms.Form):
    quantity = forms.IntegerField


class ReviewForm(forms.Form):
    score = forms.IntegerField(min_value=1, max_value=5, help_text="The score cannot be less than 1 and greater than 5.")
    text = forms.CharField(widget=forms.Textarea, max_length=800)

FinalProject/cPhilosophy/templates/review/review_delete.html
{% extends 'index.html' %}
{% load crispy_forms_filters %}
{% block title %}<title>Delete review</title>{% endblock %}
{% block content %}
    <div class="parent-del">
        <div class="updt">
            <div class="containerLogin">
                <form action="" enctype="multipart/form-data" method="post">
                    {% csrf_token %}
                    <p>Do you want to delete this comment?</p>
                    <input type="submit" value="Yes" class="button-mull" id="sb-prod-del">
                </form>
                <form action="{% url 'prod-view-review' review.product.pk %}" method="get">
                    {% csrf_token %}
                    <input type="submit" value="No" class="button-mull" id="sb-prod-del" style="margin-top:15px;">
                </form>
            </div>
        </div>
    </div>
{% endblock %}

FinalProject/cPhilosophy/templates/review/review_update.html
{% extends 'index.html' %}
{% load crispy_forms_filters %}
{% block title %}
    <title>Review update</title>
{% endblock %}

{% block content %}

    <div class="parent-del">
        <div class="updt">
            <div class="containerLogin" id="review-template">
                <div class="categ-create">
                    <p><strong>Update your <i> review </i></strong></p>
                </div>
                <form action="" method="post" enctype="multipart/form-data" id="form-review">
                    {% csrf_token %}

                    <div id='id_score' class="control-group">
                        <div class="wrap-inp">
                            <label for="id_score" class="control-label">
                                <p style="margin-right:15px;">Rating:   {{ form.score }}</p>
                            </label>
                        </div>
                    </div>
                    <div class="hr-wrap">
                        <hr>
                    </div>
                    <div id='id_text' class="control-group">
                        <label for="id_text" class="control-label">
                            <div class="txt">Text</div>
                        </label>
                        <div class="controls">
                            <label for="field"></label>
                            {{ form.text }}
                        </div>
                        {% if form.text.errors %}
                            <ol>
                                {% for error in form.text.errors %}
                                    <div class="errorss">
                                        <strong>{{ error|escape }}</strong>
                                    </div>
                                {% endfor %}
                            </ol>

                        {% endif %}
                        <div class="characters">
                            <span id="charNum"> </span> <span id="charText"></span>
                        </div>
                    </div>
                    <div class="wrapper-sub-rev">
                        <input type="submit" value="Update" class="button-mull" id="sb-review">
                        <a href="{% url 'prod-view-review' prod_pk %}" class="button-mull" id="but-back">Back</a>
                    </div>
                </form>
            </div>
        </div>
    </div>
{% endblock %}